#include <time.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <pthread.h>

extern "C" {
#include <immintrin.h>
}

void mult_original(float* a, float* b, float*c, int matrix_size, int thread_count) {
	for ( int i = 0; i < matrix_size; i++ ) {
		for ( int j = 0; j < matrix_size; j++ ) {
			c[i*matrix_size+j] = 0;
			for ( int k = 0; k < matrix_size; k++ ) {
				c[i*matrix_size+j] += a[i*matrix_size+k]*b[k*matrix_size+j];
			}
		}
	}
}

void mult_transpose(float* a, float* b, float*c, int matrix_size, int thread_count) {
	float* bt = (float*)malloc(sizeof(float)*matrix_size*matrix_size);
	for ( int i = 0; i < matrix_size; i++ ) {
		for ( int j = 0; j < matrix_size; j++ ) {
			bt[i*matrix_size+j] = b[j*matrix_size+i];
		}
	}

	for ( int i = 0; i < matrix_size; i++ ) {
		for ( int j = 0; j < matrix_size; j++ ) {
			c[i*matrix_size+j] = 0;
			for ( int k = 0; k < matrix_size; k++ ) {
				c[i*matrix_size+j] += a[i*matrix_size+k]*bt[j*matrix_size+k];
			}
		}
	}
	free(bt);
}

void mult(float* a, float* b, float*c, int matrix_size, int thread_count) {
	mult_original(a,b,c,matrix_size,thread_count);
}
